library(dplyr)
library(readr)
library(Matrix)
library(matrixStats)
library(psych)
library(tidyr)
library(ggplot2)
library(pheatmap)
library(RColorBrewer)
library(progress)
library(biomaRt)
library(grid)
library(qvalue)
library(impute)
library(WriteXLS)
library(plotROC)
library(ROCR)
source("../../code/ggmatplot.R")
source("./code/auxFunctions.R")
source("../../code/multiplot.R")
source("../../code/Wilcoxon.z.matrix.R")
source("../../code/progressTime.R")
source("../../code/GetFDR.R")
source("../../code/Wilcoxon.z.matrix.R")
source("./code/boxplotMutation.R")
source("./code/boxplotEssentiality.R")
source("./code/getPairs_mut.R")
source("./code/predictBiomarkers_mut.R")
source("./code_lu/F_EG_Selection.R")
source("./code_lu/F_predictBiomarkers_trans.R")
source("./code/getPairs_tr.R")
source("Z:/BACKUP_GRUPO/FernandoCarazo/ProyectosCompletos/hnRNP_Huelga_Analysis/GT_analysis/GT_analysis3.R")
source("./code/F_get_exp_genes.R")
source("./code/F_filter_tr_gn_and_getGN.R")
source("./code/getPairs_tr2.R")



# Load and prepare data ---------------------------------------------------

CCLE_demeter_sample_info <- read.csv("./data/input/DEMETER/TableS1_SampleInfo.csv", sep = ";", stringsAsFactors = F)
ExpandedGeneZSolsCleaned <- read_csv("./data/input/DEMETER/ExpandedGeneZSolsCleaned.csv")
ExpandedGeneZSolsCleaned <- as.data.frame(ExpandedGeneZSolsCleaned)
rownames(ExpandedGeneZSolsCleaned) <- ExpandedGeneZSolsCleaned[,1]
ExpandedGeneZSolsCleaned <- as.matrix(ExpandedGeneZSolsCleaned[,-1])
library(impute)
Salida <- impute.knn(as.matrix(ExpandedGeneZSolsCleaned) ,k = 10, rowmax = 0.75, colmax = 0.8, maxp = 1500, rng.seed=362436069)
CCLE_demeter <- Salida$data
tissue <-  as.factor(unlist(lapply(strsplit(colnames(CCLE_demeter),"_"), function(x) {paste(x[-1],sep="",collapse="_")})))
# SVD <- svd(CCLE_demeter)
# boxplot(SVD$v[,1] ~ tissue)
rm(Salida)

# MAtch samples
iC <- match(colnames(CCLE_demeter),CCLE_demeter_sample_info$Name)
CCLE_demeter_sample_info <- CCLE_demeter_sample_info[iC,]
identical(CCLE_demeter_sample_info$Name, colnames(CCLE_demeter)) # TRUE
rm(iC)

# Transcript expression

# load expression data
load(file = "D:\\Users\\fcarazo\\Documents\\Bunker\\Samples\\CCLE-Kallisto\\CCLE_tpm_all.RData")
load("D:/Users/fcarazo/Documents/Bunker/Samples/CCLE-Kallisto/CCLE_tpm_gn_allGenes.RData")
load(file = "D:\\Users\\fcarazo\\Documents\\Bunker\\Samples\\CCLE-Kallisto\\CCLE_sample_info_all.RData")

CCLE_sample_info_all <- CCLE_sample_info; rm(CCLE_sample_info)
CCLE_tpm_gn_all <- CCLE_tpm_gn; rm(CCLE_tpm_gn)
CCLE_tpm_gn_all <- as.data.frame(CCLE_tpm_gn_all)

CCLE_tpm_all_log2 <- log2(1+CCLE_tpm_all[,-1])
rownames(CCLE_tpm_all_log2) <- getBM$Transcript_ID

gnAux <- CCLE_tpm_gn_all$Gene_ID
CCLE_tpm_gn_all_log2 <- log2(1+CCLE_tpm_gn_all[,-1])
rownames(CCLE_tpm_gn_all_log2) <- gnAux
iG <- match(rownames(CCLE_tpm_gn_all_log2), getBM$Gene_ID)
rownames(CCLE_tpm_gn_all_log2) <- make.unique(getBM$Gene_name[iG])

rm(CCLE_tpm_all, CCLE_tpm_gn_all, gnAux, iG)
identical(colnames(CCLE_tpm_gn_all_log2), CCLE_sample_info_all$CCLE.name) # TRUE

### Matching Samples ---------------------------------------------------------------
iM <- match(colnames(CCLE_demeter), CCLE_sample_info_all$CCLE.name)
CCLE_demeter_match <- CCLE_demeter[, !is.na(iM)]
CCLE_demeter_sample_info_match <- CCLE_demeter_sample_info[!is.na(iM), ]
iM <- iM[!is.na(iM)]
CCLE_sample_info_match <- CCLE_sample_info_all[iM,]
CCLE_tpm_log2_match <- as.matrix(CCLE_tpm_all_log2[,iM])
rownames(CCLE_tpm_log2_match) <- getBM$Transcript_ID
CCLE_tpm_gn_log2_match <- as.data.frame(CCLE_tpm_gn_all_log2[,iM])
CCLE_tpm_gn_match <- (2^CCLE_tpm_gn_log2_match)-1

dim(CCLE_tpm_log2_match) # 199169    412
dim(CCLE_demeter_match) # 17098   412
dim(CCLE_tpm_gn_log2_match) # 60554   412

identical(colnames(CCLE_tpm_log2_match), colnames(CCLE_demeter_match)) # TRUE
identical(colnames(CCLE_tpm_log2_match), CCLE_demeter_sample_info_match$Name) # TRUE
identical(colnames(CCLE_tpm_log2_match), CCLE_sample_info_match$CCLE.name) # TRUE
identical(colnames(CCLE_tpm_log2_match), colnames(CCLE_tpm_gn_log2_match)) # TRUE
identical(colnames(CCLE_tpm_log2_match), colnames(CCLE_tpm_gn_match)) # TRUE

# CCLE_sample_info_match <- data.frame(Primary.Disease = CCLE_demeter_sample_info_match$Primary.Disease, CCLE_sample_info_match)


##############################################################################
# Positive controls
##############################################################################

x11();boxplot(CCLE_demeter_match["PIK3CA", CCLE_sample_info_match$CCLE.name] ~ CCLE_sample_info_match$PIK3CA, main = "PIK3CA", xlab = "Mutation PIK3CA", ylab = "DEMETER PIK3CA")
x11();boxplot(CCLE_demeter_match["BRAF", CCLE_sample_info_match$CCLE.name] ~ CCLE_sample_info_match$BRAF, main = "BRAF", xlab = "Mutation BRAF", ylab = "DEMETER BRAF")
x11();boxplot(CCLE_demeter_match["KRAS", CCLE_sample_info_match$CCLE.name] ~ CCLE_sample_info_match$KRAS, main = "KRAS", xlab = "Mutation KRAS", ylab = "DEMETER KRAS")
x11();boxplot(CCLE_demeter_match["NRAS", CCLE_sample_info_match$CCLE.name] ~ CCLE_sample_info_match$NRAS, main = "NRAS", xlab = "Mutation NRAS", ylab = "DEMETER NRAS")
# MDM2 and MDM4: p53 regulators as targets in anticancer therapy
x11();boxplot(CCLE_demeter_match["MDM4", CCLE_sample_info_match$CCLE.name] ~ CCLE_sample_info_match$TP53, main = "MDM4 - TP53", xlab = "Mutation TP53", ylab = "DEMETER MDM4")
x11();boxplot(CCLE_demeter_match["MDM2", CCLE_sample_info_match$CCLE.name] ~ CCLE_sample_info_match$TP53, main = "MDM2 - TP53", xlab = "Mutation TP53", ylab = "DEMETER MDM4")

# AML
# x11();boxplot(CCLE_demeter_match["FLT3", iCL] ~ CCLE_sample_info_match$FLT3[iCL], main = "FLT3 (AML)", xlab = "Mutation FLT3", ylab = "DEMETER FLT3")


##################################################
# Disease
##################################################

iCL <- grep("AML", CCLE_demeter_sample_info_match$Subtype); tag <-  "AML; n = 15" 

iCL <- which((CCLE_sample_info_match$Subtype %in% c("adenocarcinoma")) &
               !(CCLE_sample_info_match$Primary.Site %in% c("ovary", "prostate", "endometrium"))); tag <- "Adeno; n = 58"

iCL <- which(CCLE_demeter_sample_info_match$Primary.Disease == "Lung SCLC"); tag <- "SCLC; n = 22"

iCL <- which(CCLE_demeter_sample_info_match$Primary.Disease == "Breast"); tag <- "BRCA; n = 34"

iCL <- which(CCLE_demeter_sample_info_match$Subtype == "Lung squamous carcinoma"); tag <- "LUSC"

iCL <- which(CCLE_sample_info_match$Primary.Site == "lung"); tag <- "Lung; n = 97"

iCL <- which(CCLE_sample_info_match$Primary.Site == "kidney"); tag <- "Kidney; n = 14"

iCL <- which(CCLE_sample_info_match$Primary.Site == "soft_tissue"); tag <- "SARC; n = 8"



if(tag ==  "ADENO-KRASmut; n = 23"){
  iKRAS <- which((CCLE_sample_info_match$KRAS == 1))
  iCL_aux <- which((CCLE_sample_info_match$Subtype[iKRAS] %in% c("adenocarcinoma")) &
                     !(CCLE_sample_info_match$Primary.Site[iKRAS] %in% c("ovary", "prostate", "endometrium")))
  iCL <- iKRAS[iCL_aux]
}


# tag <- "ADENO-KRASwt; n = 32"
if(tag ==  "ADENO-KRASwt; n = 32"){
  iKRAS <- which((CCLE_sample_info_match$KRAS == 0))
  iCL_aux <- which((CCLE_sample_info_match$Subtype[iKRAS] %in% c("adenocarcinoma")) &
                     !(CCLE_sample_info_match$Primary.Site[iKRAS] %in% c("ovary", "prostate", "endometrium")))
  iCL <- iKRAS[iCL_aux]
}

##################################################
# Selection of Target Genes (DEMETER)
##################################################

esGene <- F_EG_Selection(Essentiality = CCLE_demeter_match, Exp_gn = CCLE_tpm_gn_match, iCL = iCL, co_enr=2, co_pess_iCL=0.25, co_exp=1,
                         qntl_exp=0.75, co_demeter=-2, impute = FALSE)

esGene <- F_EG_Selection(Essentiality = CCLE_demeter_match, Exp_gn = CCLE_tpm_gn_match, iCL = iCL, co_enr=1, co_pess_iCL=0.2, co_exp=1,
                         qntl_exp=0.75, co_demeter=-2, impute = FALSE)

##################################################
##################################################
# Main mutations-------------------------------------------------
##################################################
##################################################

CLxMut <- as.matrix(CCLE_sample_info_match[,6:ncol(CCLE_sample_info_match)])
CLxMut[is.na(CLxMut)] <- 0

# GENES NOT MAPPED
colnames(CLxMut)[grep("KMT2A", colnames(CLxMut))] <- "MLL"
rownames(CCLE_demeter_match)[grep("KMT2A", rownames(CCLE_demeter_match))] <- "MLL"
rownames(CCLE_demeter_match)[grep("KMT2C", rownames(CCLE_demeter_match))] <- "MLL3"
colnames(CLxMut)[grep("KMT2C", colnames(CLxMut))] <- "MLL3"

# Actualizar CIMA mut

if(tag == "AML; n = 15" ){
  CLxMut[iCL[c(8, 10, 11)], "TP53"] <- 1
  CLxMut[iCL[c(3)], "KDM6A"] <- 1
  CLxMut[iCL[c(3)], "CDKN2A"] <- 1
  CLxMut[iCL[c(4)], "MLL"] <- 1
  CLxMut[iCL[c(5,11)], "MLL"] <- 0
  CLxMut[iCL[c(5,8)], "FLT3"] <- 1
  CLxMut[iCL[c(11)], "FLT3"] <- 0
  CLxMut[iCL[c(10)], "KRAS"] <- 1
}

iGn <- match(rownames(esGene), rownames(CCLE_demeter_match))
predictBiomarkers <- predictBiomarkers_mut(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, co_pMut_iCL = 0.2, iGn = iGn, iCL = iCL, restCL = TRUE)



# Analysis ----------------------------------------------------------------

MagicCube_Mut <- predictBiomarkers$MagicCube_Mut
Fit_mut_list <- predictBiomarkers$Fit_mut_list

# Get Pairs

Pairs <- getPairs_mut(predictBiomarkers_mut = predictBiomarkers, co_pv = 0.05, co_lfdr = 0.2, co_DeltaEs = 2, Dir = FALSE, String = FALSE)

load("./data/output/geneInfo.RData")
Pairs <- merge(Pairs, Gene_Info, by.x = "Gene_E", by.y = "hgnc_symbol", all.x = T, all.y = F)
iM <- match(Pairs$Mutation, Gene_Info$hgnc_symbol)
Pairs$transcript_length <- Gene_Info$transcript_length[iM]
Pairs <- Pairs[order(Pairs$lfdr), ]
rownames(Pairs) <- NULL



# Mutations in patients ---------------------------------------------------

# Mutation in SCLC Patients (110 Patients) cBioportal
if(tag == "SCLC; n = 22"){
  Mutated_Genes <- read.csv("./data/input/mutations_cBioportal_Patients_SCLC/Mutated Genes.txt", header = T, stringsAsFactors = F, sep = "\t")
  Mutated_Genes$Freq <- as.numeric(sub("%", "", Mutated_Genes$Freq))
  iMut_Pat <- match(Pairs$Mutation, Mutated_Genes$Gene)
  Pairs$pMutPatient <- Mutated_Genes$Freq[iMut_Pat]
}
Pairs <- Pairs[order(Pairs$lfdr), ]
rownames(Pairs) <- NULL

# Mutation in ADENO Patients (230 Patients) cBioportal
if(tag %in% c("ADENO-KRASwt; n = 32", "ADENO-KRASmut; n = 23", "Adeno; n = 58")){
  Mutated_Genes <- read.csv("./data/input/mutations_cBioportal_Patients_ADENO_TCGA/Mutated Genes_ADENO.txt", header = T, stringsAsFactors = F, sep = "\t")
  Mutated_Genes$Freq <- as.numeric(sub("%", "", Mutated_Genes$Freq))
  iMut_Pat <- match(Pairs$Mutation, Mutated_Genes$Gene)
  Pairs$pMutPatient <- Mutated_Genes$Freq[iMut_Pat]
}
Pairs <- Pairs[order(Pairs$lfdr), ]
rownames(Pairs) <- NULL

# soft tissue TCGA PanCanAtlas genomic data from 11k cases and all TCGA tumor types cBioportal
if(tag %in% c("SARC; n = 8")){
  Mutated_Genes <- read.csv("./data/input/mutations_cBioportal_Patients_SARC/Mutated Genes_SARC.txt", header = T, stringsAsFactors = F, sep = "\t")
  Mutated_Genes$Freq <- as.numeric(sub("%", "", Mutated_Genes$Freq))
  iMut_Pat <- match(Pairs$Mutation, Mutated_Genes$Gene)
  Pairs$pMutPatient <- Mutated_Genes$Freq[iMut_Pat]
}
Pairs <- Pairs[order(Pairs$lfdr), ]
rownames(Pairs) <- NULL


# Reorder columns ---------------------------------------------------------

Pairs <- Pairs %>% dplyr::select(Gene_E, Mutation, deltaEs,# pMutPatient,
                                 P.Value,lfdr, nDeath_Target, nTargettable,pDeathTot,
                                 pDeathTarget, Ess_Target, Ess_NoTarget,
                                 RestCL_deltaEs, RestCL_t, RestCL_P.Value, Same_Dir,
                                 String, Triade, Driver, nMut, gene_biotype,
                                 transcript_length, Loc, Cancer, Drug, Indication,
                                 Function, Metabolic, molCIMA)

# Pairs <- Pairs %>% dplyr::select(Gene_E, Mutation, deltaEs, pMutPatient, P.Value,
#                                  lfdr, nDeath_Target, nTargettable,pDeathTot,
#                                  pDeathTarget, Ess_Target, Ess_NoTarget,
#                                  RestCL_deltaEs, RestCL_t, RestCL_P.Value, Same_Dir,
#                                  String, Triade, Driver, nMut)

# fileDest <- "./data/output/results/carmenPalacios/"
# write.csv2(Pairs, file = paste0(fileDest, "Pairs.csv"))

#  MONTSE SWI --------------------------------------------

# SWI
i <- 0
Mutation <- "ADAM17"
SWI_gene <- c("SMARCA4",	"SMARCD1",	"SMARCB1",	"ARID1A", "SMARCC2",	"SMARCD2",	"ACTL6A",	"SMARCD3",	"SMARCE1",	"TOP2B")

View(Pairs[Pairs$Gene_E %in% SWI_gene, ])

i <- i+1; 
fileDest <- "./data/output/results/2018-07-19 Preguntas Montse/SW-SNF_related/"
# pdf(file = paste0(fileDest, sprintf("%s.%s-%s_boxplot.pdf", i, SWI_gene[i], Mutation)), width = 12, height = 4.3)
boxplotMutation(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, iCL = iCL, Gene_E = SWI_gene[i], Mutation = Mutation, tag = tag)
# dev.off()

Mutation <- "CREBBP"
Gene_E <- "SMARCB1"
boxplotMutation(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, iCL = iCL, Gene_E = Gene_E, Mutation = Mutation, tag = tag)


##################################################
# Analysis mutations
##################################################

# Markers and targets -----------------------------------------------------

i <- 0
i <- i+1

grep("IRAK1", Pairs$Gene_E); i <- 5

boxplotMutation(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, iCL = iCL, Gene_E = Pairs$Gene_E[i], Mutation = Pairs$Mutation[i], tag = tag)

length(Pairs$Mutation[Pairs$lfdr < 0.2])
length(unique(Pairs$Mutation[Pairs$lfdr < 0.2]))
sort(table(Pairs$Mutation[Pairs$lfdr < 0.2]), decreasing = T)

BestMarkers <- as.data.frame(sort(table(Pairs$Mutation[Pairs$lfdr < 0.2]), decreasing = T))
Neg <- as.data.frame(Pairs %>% group_by(Mutation) %>% summarise(Neg = sum(deltaEs < 0)))
BestMarkers <- merge(BestMarkers, Neg, by.x = "Var1", by.y = "Mutation")
Pos <- Pairs %>% group_by(Mutation) %>% summarise(Pos = sum(deltaEs > 0))
BestMarkers <- merge(BestMarkers, Pos, by.x = "Var1", by.y = "Mutation")
BestMarkers <- BestMarkers[BestMarkers$Freq >2, ]
BestMarkers <- BestMarkers[order(BestMarkers$Freq, decreasing = T), ]
rownames(BestMarkers) <- NULL
BestMarkers$pNeg <- round(BestMarkers$Neg/BestMarkers$Freq * 100, 2)
BestMarkers$pPos <- round(BestMarkers$Pos/BestMarkers$Freq * 100, 2)

length(unique(Pairs$Gene_E[Pairs$lfdr < 0.2]))


mutTop <- names(sort(table(Pairs$Mutation[Pairs$lfdr < 0.2]), decreasing = T))

k <- 0
k <- k+1

hist(predictBiomarkers$Fit_mut_list[[mutTop[k]]]$p.value, 100, main = sprintf("histogram of P-values of %s", mutTop[k]))


# View biomarkers for a gene
View(MagicCube_Mut["PLK1", ,])

# View gene essentials for a mutation
View(MagicCube_Mut[,"EP300" ,])

# View volcano plot for a mutation
mutation <- "TP53"
h <- 20
FitA <- Fit_mut_list[[mutation]]

fileDest <- "./data/output/results/2017-12-19 Adeno_Mutations_magicCube/Adeno-KRAS/"

# pdf(file = paste0(fileDest, sprintf("volcanoPlot_%s.pdf", mutation)), width = 6.98, height = 4.25)
volcanoplot(FitA, highlight = h, names = rownames(CCLE_demeter_match)[iGn], main = paste("Essential genes of mutation ", mutation, "\n(left: treatment when mutated)"), xlab = "Increment of Essentiality")
# dev.off()

boxplotMutation(CCLE_demeter_match, CLxMut, iCL, Gene_E = "BCLAF1", Mutation = "CHD1", tag = tag)

# just for EP300 combined therapy

aux_Es <- data.frame(t(CCLE_demeter_match))
aux_Es$KLF2_and_BPTF <- colMins(rbind(aux_Es$KLF2, aux_Es$BPTF))
aux_Es <- t(aux_Es)
aux_Es <- as.matrix(aux_Es)
boxplotMutation(aux_Es, CLxMut, iCL, Gene_E = "KLF2_and_BPTF", Mutation = "EP300", tag = tag)

aux <- data.frame(MagicCube_Mut[,"TP53",])
boxplot(-log10(aux$P.Value) ~ aux$Same_Dir)
boxplot(-log10(aux$P.Value) ~ aux$String)

# KRAS MUT
i <- 7
gn <- Pairs$Gene_E[i]
mut <- Pairs$Mutation[i]
boxplotMutation(CCLE_demeter_match[, iKRAS], CLxMut[iKRAS, ], iCL_aux, Gene_E = gn, Mutation = mut, tag = tag)

# Boxplot mutations
j <- 1

fileDest <- "./data/output/results/2018-03-09_ADENO_New_lfdr/"
j <- j+1

for(j in 1:nrow(Pairs)){
  Gene_E <- Pairs$Gene_E[j]
  Mutation <- Pairs$Mutation[j]
  
  pdf(file = paste0(fileDest, sprintf("%s.%s-%s_boxplot.pdf", j, Gene_E, Mutation)), width = 12, height = 4.3)
  boxplotMutation(CCLE_demeter_match, CLxMut, iCL, Gene_E, Mutation = Mutation, tag = tag)
  dev.off()
}

boxplotMutation(CCLE_demeter_match, CLxMut, iCL, Gene_E, Mutation = Mutation, tag = tag)


##################################################
# Cell Lines Info
##################################################

if(tag == "SCLC; n = 22") Pairs <- Pairs[c(1:8,12,32,47,49,53,59,92,103,113,135,150), ] 

CLmutations <- CLxMut[iCL, unique(Pairs$Mutation)]
Essentiality_aux <- CCLE_demeter_match
colnames(Essentiality_aux) <- rownames(CLxMut)

CLessentiality_DIC <- t(Essentiality_aux[unique(Pairs$Gene_E), iCL] < -2)*1

# 
# mutCIMA <- c("ETV6", "JAK2", "TP53", "SETBP1", "KDM6A", "CUX1", "NRAS", "CDKN2A", "RAD21", "MLL", "ASXL1", "KIT", "BCOR", "NOTCH1", "CBL", "FLT3", "KRAS", "DNMT3A")
# iCIMA <- match(mutCIMA, colnames(CLxMut))
# CLmutations_cima <- CLxMut[iCL[c(3,4,5,8,9,10,11,15)], iCIMA]


# Generation .CSV for CIMA

print = FALSE
fileDest <- "./data/output/results/2018-03-02_SCLC_New_lfdr/"
if(print){
  write.csv2(CLmutations, file = paste0(fileDest, "CL_mutations.csv"))
  write.csv2(CLessentiality_DIC, file = paste0(fileDest, "CL_essential.csv"))
  # write.csv2(CLmutations_cima, file = paste0(fileDest, "CL_mutations_CIMA.csv"))
}


Mut = "NPM1"
i <- 0
i <- i+1
Mut <- unique(Pairs$Mutation)[i]
gns_mut <- Pairs$Gene_E[Pairs$Mutation == Mut]
n_mut <- sum(CLmutations[, which(colnames(CLmutations) == Mut)])
iCL_mut_wt <- iCL[c(which(CLmutations[, which(colnames(CLmutations) == Mut)] == 1),which(CLmutations[, which(colnames(CLmutations) == Mut)] == 0))]

CLessentiality <- (Essentiality_aux[gns_mut, iCL_mut_wt])
# colnames(CLessentiality) <- gsub(pattern = "_HAEMATOPOIETIC_AND_LYMPHOID_TISSUE","",colnames(CLessentiality))
# colnames(CLessentiality)[1:n_mut] <- paste0(colnames(CLessentiality)[1:n_mut], "_", Mut, "mut")

aux <- CLessentiality

info <- data.frame(mut = as.factor(CLmutations[, which(colnames(CLmutations) == Mut)]))
colnames(info) <- paste0("mut",Mut)
levels(info[,1]) <- c("WT", "MUT")

# aux[aux <= -3.92] <- -5

dw <- -4
up <- 2
aux[aux <= dw] <- dw
aux[aux > up] <- up

fileDest <- "./data/output/results/2018-03-02_SCLC_New_lfdr/heatmaps/"  
filename <- paste0(fileDest, sprintf("%s.%smut_heatmap.pdf", i, Mut))
width = 12
height = 3

if(length(nrow(aux)) == 0){
  aux2 <- rbind(aux, aux)
  rownames(aux2) <- rep(gns_mut, 2)
  pheatmap(aux2, color = colorRampPalette(brewer.pal(n = 7, name = "RdYlGn"))(100), cluster_cols = F, annotation_col = info, annotation_legend = TRUE,
                  display_numbers = round(rbind(CLessentiality,CLessentiality),2), cutree_rows =  NA,  main = paste0("Essential genes (when ", Mut, " MT / WT)\n", tag), 
                  legend_breaks = c(dw,-.5,up), legend_labels = c(round(min(CLessentiality)), 0, round(max(CLessentiality))))
  # , filename = filename, width = width, height = height
  
}else{
  height = 4
  
  pheatmap(aux, color = colorRampPalette((brewer.pal(n = 7, name = "RdYlGn")))(100), cluster_cols = F, annotation_col = info, annotation_legend = TRUE,
                  display_numbers = round(CLessentiality,2), cutree_rows =  NA,  main = paste0("Essential genes (when ", Mut, " MT / WT)\n", tag), 
                  legend_breaks = c(dw,-.5,up), legend_labels = c(round(min(CLessentiality)), 0, round(max(CLessentiality))))
  # , filename = filename, width = width, height = height
}

X11(); pheatmap(CLessentiality, color = colorRampPalette((brewer.pal(n = 7, name = "RdYlGn")))(100), cluster_cols = F, annotation_col = info, annotation_legend = TRUE,
                display_numbers = round(CLessentiality,2), cutree_rows =  2,  main = paste0("Essential genes (when ", Mut, " MT / WT)\n", tag))

plot(CLessentiality)

boxplotMutation(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, iCL = iCL, Gene_E = "KDM1A", Mutation = "NPM1", tag = tag)

# iaux <- which(colnames(CCLE_sample_info_match) %in% Pairs$Mutation)
# write.csv2(CCLE_sample_info_match[iCL, c(1:5,iaux)], file = paste0(fileDest, "CellLines_SCLC.csv"), row.names = F, quote = F)


# Adeno-KRASmut

# gns_mut <- Pairs$Gene_E[c(1,4,6,7)] #  "SMC2"   "MDM4"   "TEAD1"  "BCLAF1"
# 
# auxMut <- Pairs$Mutation[c(1,4,6,7)]
# auxCLxMut <- data.frame(CLxMut[iCL, auxMut])
# auxCLxMut$TP53 <- trunc(2^-auxCLxMut$TP53)
# auxCLxMut$CHD9 <- trunc(2^-auxCLxMut$CHD9)
# auxCLxMut <- t(auxCLxMut)
# 
# CLessentiality <- CCLE_demeter_match[gns_mut, iCL]
# aux <- CLessentiality
# 
# aux[which(auxCLxMut == 0)] <- 0
# 
# aux[aux < -3] <- -3
# aux[aux > 2] <- 2
# 
# rownames(aux) <- paste(rownames(auxCLxMut), rownames(aux), sep = "-")
# 
# info <- data.frame(apply(auxCLxMut, 2, as.factor))
# 
# colnames(info) <- paste0(colnames(info), "mut")
# 
# levels(info[,1]) <- c("WT", "MUT")
# levels(info[,2]) <- c("WT", "MUT")
# levels(info[,3]) <- c("WT", "MUT")
# levels(info[,4]) <- c("WT", "MUT")
# 
# rownames(info) <- colnames(aux)
# 
# x11();pheatmap(aux, annotation_col = info, color = colorRampPalette((brewer.pal(n = 7, name = "RdYlGn")))(100), cluster_cols = T,
#          display_numbers = round(CLessentiality,2), 
#          legend_breaks = c(-3,-.5,2), legend_labels = c(round(min(CLessentiality)), 0, round(max(CLessentiality))),
#          main = "Essentiality score of cell lines (DEMETER score) \n (Colour ones are targetables)")
# 
# dirOut <- "./data/output/results/2018-01-26 Selection_of_CL_LUNG/"
# 
# iaux <- which(colnames(CCLE_sample_info_match) %in% c("TP53", "TLK1", "CHD1", "CHD9"))


# write.csv2(CCLE_sample_info_match[iCL_adeno, iaux], file = paste0(dirOut, "CellLines_Adeno.csv"))


##################################################
# Ruben
##################################################

iCL <- which(CCLE_sample_info_match$Primary.Site == "lung"); tag <- "Lung"

iGn <- match(c("FGFR1", "DSTYK"), rownames(CCLE_demeter_match))
predictBiomarkers <- predictBiomarkers_mut(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, co_pMut_iCL = 0.2, iGn = iGn, iCL = iCL, restCL = TRUE)

# View biomarkers for a gene
MagicCube_Mut <- predictBiomarkers$MagicCube_Mut

tableFGFR1 <- (MagicCube_Mut["FGFR1", ,])

esFGFR1 <- 1*(CCLE_demeter_match["FGFR1", iCL] < -2)
aux <- data.frame(subtype = CCLE_sample_info_match$Subtype[iCL], esFGFR1)
SubtypeFGFR1 <- data.frame(aux %>% group_by(subtype) %>% summarise(es = sum(esFGFR1)))
SubtypeFGFR1 <- SubtypeFGFR1[order(SubtypeFGFR1$es, decreasing = T),]
rownames(SubtypeFGFR1) <- NULL


##################################################
# Genomic inestability SCLC
##################################################

# Get ALL calculated Pairs 
Pairs <- getPairs_mut(predictBiomarkers_mut = predictBiomarkers, co_pv = 1, co_lfdr = 1, co_DeltaEs = 0, Dir = FALSE, String = FALSE)

hist(Pairs$P.Value,100)
boxplot(log10(Pairs$P.Value) ~ Pairs$String)
hist(Pairs$P.Value[which(Pairs$String == 1)],200)
hist(Pairs$P.Value[which(Pairs$String == 0)],500)
hist(Pairs$P.Value[which(Pairs$Same_Dir == 1)],500)
hist(Pairs$P.Value[which(Pairs$Same_Dir == 0)],500)

isICL <- rep("Rest CLs", nrow(CLxMut))
isICL[iCL] <- "SCLC"
boxplot((rowSums(CLxMut))~isICL, xlab = "Number of mutations", main = "Frequency of mutations in CLs", ylim = c(0,300))
wilcox.test((rowSums(CLxMut))~isICL)

# aux <- data.frame(nMut = rowSums(CLxMut), CL = isICL)
# aux %>% group_by(CL) %>% summarize(median(nMut))
# # A tibble: 2 x 2
# A tibble: 2 x 2
# CL       `median(nMut)`
# <fct>             <dbl>
#   1 Rest CLs           93.0
#   2 SCLC              109  

# Selected mutations are more frequently mutated than the rest of genes
isGn <- rep("Rest Genes", ncol(CLxMut))
isGn[which(colnames(CLxMut) == "CREBBP")] <- "CREBBP"
isGn[which(colnames(CLxMut) == "TRRAP")] <- "TRRAP"
isGn[which(colnames(CLxMut) == "TP53")] <- "TP53"
boxplot((colSums(CLxMut))~isGn, xlab = "Number of mutations", main = "Frequency of mutations in genes")

isGn <- rep("Rest Genes", ncol(CLxMut))
isGn[which(colnames(CLxMut) %in% unique(Pairs$Mutation))] <- "Sel Mutation"
boxplot((colSums(CLxMut[iCL,]))~isGn, ylab = "Number of mutations", main = "Frequency of mutations in genes")


#------------------ total number of mutations is a better marker of essentiality than CREBBPmut

# Both CREBBP and TRRAP are correlated with the total number of mutations
boxplot(rowSums(CLxMut) ~ CLxMut[, which(colnames(CLxMut) == "CREBBP")], main = "Frequency of mutations (all cell lines)", xlab = "CREBBP mutated", ylab = "Mut. frequency")
wilcox.test(rowSums(CLxMut) ~ CLxMut[, which(colnames(CLxMut) == "CREBBP")])
boxplot(rowSums(CLxMut) ~ CLxMut[, which(colnames(CLxMut) == "TRRAP")],main = "Frequency of mutations (all cell lines)", xlab = "TRRAP mutated", ylab = "Mut. frequency")
wilcox.test(rowSums(CLxMut) ~ CLxMut[, which(colnames(CLxMut) == "TRRAP")])

boxplot(rowSums(CLxMut[iCL, ]) ~ CLxMut[iCL, which(colnames(CLxMut) == "CREBBP")], main = "Frequency of mutations (SCLC cell lines)", xlab = "CREBBP mutated", ylab = "Mut. frequency")
wilcox.test(rowSums(CLxMut[iCL, ]) ~ CLxMut[iCL, which(colnames(CLxMut) == "CREBBP")])
boxplot(rowSums(CLxMut[iCL, ]) ~ CLxMut[iCL, which(colnames(CLxMut) == "TRRAP")], main = "Frequency of mutations (SCLC cell lines)", xlab = "TRRAP mutated", ylab = "Mut. frequency")
wilcox.test(rowSums(CLxMut[iCL, ]) ~ CLxMut[iCL, which(colnames(CLxMut) == "TRRAP")])


boxplot(rowSums(CLxMut) ~ CLxMut[, which(colnames(CLxMut) == "NPM1")], main = "Frequency of mutations (all cell lines)", xlab = "NPM1 mutated", ylab = "Mut. frequency")
boxplot(rowSums(CLxMut[iCL, ]) ~ CLxMut[iCL, which(colnames(CLxMut) == "NPM1")], main = "Frequency of mutations (SCLC cell lines)", xlab = "NPM1 mutated", ylab = "Mut. frequency")



# ... but the total number of mutations is not as good a marker as CREBBP mutations
boxplot(CCLE_demeter_match["SMARCA4", iCL]~(rowSums(CLxMut[iCL, ])>median(rowSums(CLxMut[iCL, ])))*1, main ="SMARCA4-NumMut", xlab = "nMut > median", ylab = "SMARCA4 essentiality")
wilcox.test(CCLE_demeter_match["SMARCA4", iCL]~(rowSums(CLxMut[iCL, ])>median(rowSums(CLxMut[iCL, ])))*1)
boxplot(CCLE_demeter_match["SMARCA4", iCL]~(CLxMut[iCL, "CREBBP"]), main = "SMARCA4-CREBBP", xlab = "CREBBP mut", ylab = "SMARCA4 essentiality")
wilcox.test(CCLE_demeter_match["SMARCA4", iCL]~(CLxMut[iCL, "CREBBP"]))

boxplot(CCLE_demeter_match["PLK1", iCL]~(rowSums(CLxMut[iCL, ]) > median(rowSums(CLxMut[iCL, ])))*1, main ="PLK1-NumMut", xlab = "nMut > median", ylab = "PLK1 essentiality")
wilcox.test(CCLE_demeter_match["PLK1", iCL]~(rowSums(CLxMut[iCL, ])>median(rowSums(CLxMut[iCL, ])))*1)

boxplot(CCLE_demeter_match["PLK1", iCL]~(CLxMut[iCL, "CREBBP"]), main ="PLK1-CREBBP", xlab = "CREBBP mut", ylab = "PLK1 essentiality")
wilcox.test(CCLE_demeter_match["PLK1", iCL]~(CLxMut[iCL, "CREBBP"]))

# Add the number of mutations as a new variable---------------------------------------
CLxMut2 <- as.data.frame(CLxMut)
CLxMut2$nMutations <- (rowSums(CLxMut2) > median(rowSums(CLxMut2[iCL, ])))*1
CLxMut2 <- as.matrix(CLxMut2)

boxplot(rowSums(CLxMut) ~ CLxMut2[, which(colnames(CLxMut2) == "nMutations")], main = "Frequency of mutations (all cell lines)", xlab = "nMut > median", ylab = "Mut. frequency")

predictBiomarkers2 <- predictBiomarkers_mut(Essentiality = CCLE_demeter_match, CLxMut = CLxMut2, co_pMut_iCL = 0.2, iGn = iGn, iCL = iCL, restCL = TRUE)
# Get all calculated Pairs 
Pairs <- getPairs_mut(predictBiomarkers_mut = predictBiomarkers2, co_lfdr = 1,co_pv = 1, String = FALSE, Dir = FALSE, co_DeltaEs = 0)

load("./data/output/geneInfo.RData")
Pairs <- merge(Pairs, Gene_Info, by.x = "Gene_E", by.y = "hgnc_symbol", all.x = T, all.y = F)
iM <- match(Pairs$Mutation, Gene_Info$hgnc_symbol)
Pairs$transcript_length <- Gene_Info$transcript_length[iM]
Pairs <- Pairs[order(Pairs$lfdr), ]
rownames(Pairs) <- NULL

# compare nMut with CREBBP
View(Pairs)


# Gene length-------------------------

aux <- Pairs %>% dplyr::select(Mutation, transcript_length)
aux <- aux[!duplicated(aux), ]
aux <- as.data.frame(aux)
summary(log2(aux$transcript_length))

summary(log2(Gene_Info$transcript_length[which(Gene_Info$gene_biotype == "protein_coding")]))
boxplot(c(log2(aux$transcript_length),
          log2(Gene_Info$transcript_length[which(Gene_Info$gene_biotype == "protein_coding")])) ~
          c(rep("Sel Mutations", nrow(aux)),
            rep("All protein coding genes", length(which(Gene_Info$gene_biotype == "protein_coding")))), 
        main = "Gene length", ylab = "bp (log2)")

boxplot(log2(Pairs$transcript_length) ~ factor(Pairs$lfdr < 0.2), xlab = "lfdr < 0.2", ylab = "bp (log2)", main = "Gene length")
wilcox.test(log2(Pairs$transcript_length) ~ (Pairs$lfdr < 0.2))

aux2 <- data.frame(Length = Pairs$transcript_length, Significative = Pairs$lfdr < 0.2)
aux2 %>% group_by(Significative) %>% summarize(Length_med = median(Length, na.rm = T))
plot(log2(Pairs$transcript_length), Pairs$nMut, pch = 16, cex=1, xlab = "Transcript length (log2)", ylab = "num Mutations", main = "Length vs Mutations")

# GDSC-----------------------------

load(file = "./data/input/PharmacoGX/GDSC_drug_data.RData")

colnames(GDSC_drug_data) <- gsub("-", "", colnames(GDSC_drug_data))
iGx <- match(CCLE_sample_info_match$Cell_Line[iCL], colnames(GDSC_drug_data))
iGx <- iGx[!is.na(iGx)]
GDSC_drug_data_match <- as.matrix(GDSC_drug_data)[,iGx]

iPh <- which(rownames(GDSC_drug_data_match) %in% c("BI-2536", "GW843682X"))

GDSC_drug_data_match[which(is.infinite(GDSC_drug_data_match))] <- 10
boxplot(GDSC_drug_data_match[iPh[1],] ~ CLxMut[iCL, "CREBBP"])


# Widley paper

IC50 <- read_delim("Z:/BACKUP_GRUPO/FernandoCarazo/ProyectosCompletos/Achilles-CCLE-TCGA/Achilles-AS/data/input/CGP/IC50_Wildey_handmade_LuFer.csv", 
                   ";", escape_double = FALSE, trim_ws = TRUE)

IC50 <- as.data.frame(IC50)
IC50$`Sample Name (wildey)` <- gsub("-", "", IC50$`Sample Name (wildey)`)

colnames(IC50)[1] <- "Cell_line"

iI <- match(CCLE_sample_info_match$Cell_Line, IC50$Cell_line)
dm_CGP <- CCLE_demeter_match["PLK1", !is.na(iI)]
Mut <- CCLE_sample_info_match[!is.na(iI), "CREBBP"]
iI <- iI [!is.na(iI)]
CGP <- data.frame(IC50[iI, ], dm_CGP)

plot(CGP$dm_CGP, CGP$BI.2536, col = Mut+1)
plot(CGP$dm_CGP, CGP$GW843682X)

##################################################
# YES1
##################################################

fileDest <- "./data/output/results/2018_01_30_YES1_2/"

# SELECTION OF SAMPLES

# iCL <- 1:ncol(CCLE_demeter_match); tag = "All Samples; n = 373"

# iCL <- which(CCLE_sample_info_match$Primary.Site != "leukemia"); tag <- "Solid tumors; n = 373"

# iCL <- which(CCLE_sample_info_match$Primary.Site == "lung"); tag <- "Lung; n = 97"

# iCL <- which(CCLE_demeter_sample_info_match$Subtype == "Lung squamous carcinoma"); tag <- "LUSC; n = 13"
# 


#-------------------------------------------------------------------

sum(CCLE_demeter_match["YES1",iCL] < -1)

plot(sort(CCLE_demeter_match["YES1",iCL]), pch = 16)
plot(CCLE_demeter_match["YES1",iCL], CCLE_tpm_gn_log2_match["YES1",iCL])


esYES1 <- factor(CCLE_demeter_match["YES1",iCL] < -1)

pv <- wilcox.test(as.numeric(CCLE_tpm_gn_log2_match["YES1",iCL]) ~ esYES1)$p.value # p-value = 0.002737

boxplot(as.numeric(CCLE_tpm_gn_log2_match["YES1",iCL]) ~ esYES1, main =sprintf("expression vs essentiality YES1 (%s)\n p.value = %.2e", tag, pv), ylab ="YES1 expression (log2)", xlab = "YES1 essentiality (DEMETER < -1)")

# Correlation between demeter values
corDemeterYES1 <- as.numeric((cor(t(CCLE_demeter_match["YES1", iCL, drop = F]), t(CCLE_demeter_match[,iCL]))))
names(corDemeterYES1) <- rownames(CCLE_demeter_match[,iCL])
corDemeterYES1 <- sort(corDemeterYES1, decreasing = T)

summary(corDemeterYES1[-1])
plot(density(corDemeterYES1[-1]), ylab = "Pearson correlation", main = sprintf("Correlation of YES1 essentiality vs rest of genes (DEMETER score) (%s)", tag)); grid()
# plot(CCLE_demeter_match["YES1",iCL], CCLE_demeter_match["TLN1",iCL])

ctCor <- 0.2
sum(corDemeterYES1 > ctCor) # 40
# cat(names(corDemeterYES1)[corDemeterYES1 > ctCor], sep = "\n")
cat(names(corDemeterYES1)[1:21], sep = "\n")


# write.csv(names(corDemeterYES1)[corDemeterYES1 > ctCor], file = "./data/output/results/2018-01-22_YES1/corDemeterUp0.2.txt", quote = F, row.names = F)
# write.csv(rownames(CCLE_demeter_match), file = "./data/output/results/2018-01-22_YES1/universeDemeter.txt", quote = F, row.names = F)


# Correlation between expression values
corExpressionYES1 <- as.numeric((cor(t(CCLE_tpm_gn_log2_match["YES1", iCL ,drop = F]), t(CCLE_tpm_gn_log2_match[,iCL]))))
names(corExpressionYES1) <- rownames(CCLE_tpm_gn_log2_match[,iCL])
corExpressionYES1 <- sort(corExpressionYES1, decreasing = T)

summary(corExpressionYES1[-1])
plot(density(corExpressionYES1[-1]),
     ylab = "Pearson correlation",
     main = sprintf("Correlation of YES1 expression vs rest of genes \n(%s)", tag)); grid()

cat(names(corExpressionYES1)[1:21], sep = "\n")

auxGn <- names(corDemeterYES1)
auxDF <- data.frame(Gene = auxGn, Cor_Essentiality = as.numeric(corDemeterYES1), Cor_Expression = as.numeric(corExpressionYES1[auxGn]))

# write.csv2(auxDF, file = paste0(fileDest, "Top_20_genes_essentiality_correlated_Lung.csv"))
# CNV

library(readr)
Copy_Number_YES1 <- read_delim("Z:/BACKUP_GRUPO/FernandoCarazo/ProyectosCompletos/Achilles-CCLE-TCGA/Achilles-AS/data/input/YES1/Copy Number_ YES1.txt", 
                               "\t", escape_double = FALSE, trim_ws = TRUE)

Copy_Number_YES1 <- Copy_Number_YES1 %>% dplyr::select(-Gene)

iCNV <- match(colnames(CCLE_demeter_match), colnames(Copy_Number_YES1))
Copy_Number_YES1 <- Copy_Number_YES1[,iCNV]

identical(colnames(CCLE_demeter_match), colnames(Copy_Number_YES1)) # TRUE
identical(colnames(CCLE_tpm_gn_match), colnames(Copy_Number_YES1)) # TRUE

plot(sort(as.numeric(Copy_Number_YES1[iCL])))

aux_CNV <- data.frame(log2Exp_YES1 = as.numeric(CCLE_tpm_gn_log2_match["YES1", iCL]), 
                      log2_CNV_YES1 = as.numeric(Copy_Number_YES1[iCL]), 
                      YES1_Essential = as.factor(CCLE_demeter_match["YES1",iCL] < -1),
                      Primary_Site = CCLE_sample_info_match$Primary.Site[iCL])
# plot(, pch = 16,, main = "Expression vs CNVs YES1", xlab = "log2 Expression YES1", ylab = "CNVs YES1")

library(ggplot2)

pv <- cor.test(aux_CNV$log2Exp_YES1, aux_CNV$log2_CNV_YES1, method = "spearman")$p.value
cor <- cor(aux_CNV$log2Exp_YES1[-which(is.na(aux_CNV$log2_CNV_YES1))], aux_CNV$log2_CNV_YES1[-which(is.na(aux_CNV$log2_CNV_YES1))], method = "spearman") 



x11(); ggplot(aux_CNV, aes(log2Exp_YES1, log2_CNV_YES1)) + 
  geom_point(aes(color = YES1_Essential), size = 1)  + ggtitle(label = sprintf("YES1. Influence of CNVs and Expression in Essentiality \n (%s)", tag)) +
  theme(plot.title = element_text(hjust = 0.5)) 
# +
# 
#   geom_text(aes(-Inf, Inf, label= sprintf("P.v = %.2e \n cor = %.2f", pv, cor)),
#             vjust = "inward",
#             hjust = "inward", color =2, size = 2)

# + geom_text(aes(label=Primary_Site, color = YES1_Essential),hjust=0, vjust=0, size = 4)
# +  scale_color_gradient(low = "yellow", high = "red")



pv <- wilcox.test(aux_CNV$CNV_YES1 ~ aux_CNV$DEMETER_YES1)$p.value # p-value = 0.02554

boxplot(aux_CNV$CNV_YES1 ~ aux_CNV$DEMETER_YES1, main =sprintf("CNVs vs essentiality YES1 (%s)\n p.value = %.2e", tag, pv), ylab ="CNVs YES1", xlab = "YES1 essentiality (DEMETER < -1)")


# Dasatinib

load("./geneInfo.RData")

Gene_Info[grep("Dasatinib",Gene_Info$Drug),]

aux <- Gene_Info[grep("Dasatinib",Gene_Info$Drug),c(1:5,8,9)]
# write.csv2(aux, "./data/output/results/2018-01-22_YES1/drugs-YES1.csv")

corDrug <- as.numeric(cor(t(CCLE_demeter_match["YES1", iCL, drop=F]), t(CCLE_demeter_match[aux$hgnc_symbol, iCL])))
names(corDrug) <- aux$hgnc_symbol
corDrug <- sort(corDrug, decreasing = T)
data.frame(corDrug)

plot(CCLE_demeter_match["YES1", iCL], CCLE_demeter_match["KIT", iCL])

rowSums(CCLE_demeter_match[aux$hgnc_symbol, iCL] < -2)


##################################################
##################################################
# Main transcripts--------------------------------
##################################################
##################################################

CCLE_tpm_match <- (2^CCLE_tpm_log2_match)-1

# Filter Transcript expression
Filt <- filter_tr_gn_and_getGN(Exp_trancripts = CCLE_tpm_match, getBM = getBM, iCL = iCL, qt = 0.5)
iT_exp <- match(Filt$T_filt, rownames(CCLE_tpm_match))
iG_exp <- match(Filt$G_filt, rownames(Filt$Exp_gn))
Exp_genes <- Filt$Exp_gn

# Get essential genes index
iGn <- match(rownames(esGene), rownames(CCLE_demeter_match))

# Predict Transcript Biomarkers
predictBiomarkers_tr <- F_predictBiomarkers_trans(Essentiality = CCLE_demeter_match, 
                                                  Exp_trancripts = CCLE_tpm_match, 
                                                  Exp_genes = Exp_genes,
                                                  iGn_ess = iGn,
                                                  iT_exp = iT_exp, 
                                                  iG_exp = iG_exp, 
                                                  iCL = iCL, 
                                                  getBM = getBM, 
                                                  co_demeter = -2, 
                                                  impute = F, restCL = F, 
                                                  string = F, shiny = F)

# MagicCube_tr <- predictBiomarkers_tr$MagicCube_Trans

Pairs_tr <- getPairs_tr_list(Tr_Bmrk_list = predictBiomarkers_tr$Tr_Bmrk_list, getBM = getBM, co_PV = 0.05, co_log2FC = 1.5)


i <- 0

i <- i+1; id <- i #id <- which(Pairs_tr$Group == "gene")[i]
tr <- Pairs_tr$Transcript_ID[id]; gn <- as.character(Pairs_tr$Gene_Ess[id]); group_bmrk <- as.character(Pairs_tr$Group_bmkr[id])

pA <- plot_transcripts_essential2(tr = tr, gn = gn, getBM = getBM,
                                  iCL = iCL, CCLE_ataris = CCLE_demeter_match, 
                                  CCLE_tpm_log2 = CCLE_tpm_log2_match,
                                  CCLE_sample_info = CCLE_sample_info_match, 
                                  method = "pearson", group_bmrk = group_bmrk,text = F, vline = -2, xnames = T)

x11();multiplot(plotlist = list(pA$gg1,pA$gg2, pA$gg5, pA$gg3),cols=2)

View(GT$B_GT)




View(MagicCube_tr["CDK4", , ])


gn <- Pairs_tr$Gene_E[1]
tr <- as.character(Pairs_tr$Transcrip_ID[1])

pA <- plot_transcripts_essential2(tr = tr, gn = gn, getBM = getBM, CCLE_ataris = CCLE_demeter_match, CCLE_tpm_log2 = log2(1+CCLE_tpm_match), CCLE_sample_info = CCLE_sample_info_match, iCL = iCL, text = F)
multiplot(plotlist = list(pA$gg1,pA$gg2, NULL, pA$gg3),cols=2)

# rm(CCLE_demeter, CCLE_demeter_sample_info, CCLE_sample_info_all, CCLE_tpm_all_log2, CCLE_tpm_gn_all_log2, ExpandedGeneZSolsCleaned, CCLE_tpm_gn_log2_match, CCLE_tpm_log2_match, iM, tissue)
# save.image("./data/output/DataForShiny.RData")
# save.image("./data/output/DataForShiny_small.RData")


# Silve -------------------------------------------------------------------

# Run until line 179: colnames(CLxMut)[grep("KMT2C", colnames(CLxMut))] <- "MLL3"

# How essential is FOSL1
par(mar=c(10,4.1,4.1,2.1))
# boxplot(main = "DEMETER FOSL1", CCLE_demeter_match["FOSL1", ] ~ CCLE_sample_info_match$Primary.Site, las = 2)
boxplot(main = "DEMETER PITPNC1", CCLE_demeter_match["PITPNC1", ] ~ CCLE_sample_info_match$Primary.Site, las = 2)
abline(h = -2, col = 2, lty = 2)


par(mar=c(15,4.1,4.1,2.1))
# aboxplot(main = paste("DEMETER FOSL1;", tag), CCLE_demeter_match["FOSL1", iCL] ~ CCLE_sample_info_match$Subtype[iCL], las = 2)
boxplot(main = paste("DEMETER PITPNC1;", tag), CCLE_demeter_match["PITPNC1", iCL] ~ CCLE_sample_info_match$Subtype[iCL], las = 2)
abline(h = -2, col = 2, lty = 2)
par(mar=c(5.1,4.1,4.1,2.1))

gns <- c("PITPNC1", "SULT2B1", "SLC1A5", "KIF20A", "HIST1H2BM")
i <- 0
i <- i+1; boxplotMutation(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, iCL = iCL, Gene_E = gns[i], Mutation = "KRAS", tag = tag)
boxplotMutation(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, iCL = iCL, Gene_E = "KRAS", Mutation = "KRAS", tag = tag)

    
# Genes Ess
genes_silve <- read.delim("./data/input/silve/genes_Silve.csv", stringsAsFactors = F)
genes_silve_ess <- genes_silve$PROTEIN.IDS[genes_silve$PROTEIN.IDS %in% rownames(esGene)]
iGnE <- match(genes_silve_ess, rownames(CCLE_demeter_match))
boxplot(main = paste("DEMETER of Silve's Genes ;", tag), t(CCLE_demeter_match[iGnE, iCL]), las = 2)
abline(h = -2, col = 2, lty = 2)

iGn <- match(genes_silve$PROTEIN.IDS, rownames(CCLE_demeter_match))
iGn <- iGn[!is.na(iGn)]

predictBiomarkers <- predictBiomarkers_mut(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, co_pMut_iCL = 0.2, iGn = iGn, iCL = iCL, restCL = TRUE)
MagicCube_Mut <- predictBiomarkers$MagicCube_Mut
Fit_mut_list <- predictBiomarkers$Fit_mut_list

# View gene essentials for a mutation
TopKRAS <- as.data.frame(MagicCube_Mut[,"KRAS" ,]); TopKRAS <- TopKRAS[order(TopKRAS$P.Value), ]
TopKRAS["FOSL1", 1:4]
boxplotMutation(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, iCL = iCL, Gene_E = "FOSL1", Mutation = "KRAS", tag = tag)


iT <- match(rownames(esGene), rownames(TopKRAS))
iT <- iT[!is.na(iT)]
TopKRAS_s <- TopKRAS[iT, ]
TopKRAS_s <- TopKRAS_s[TopKRAS_s$P.Value < 0.05, ]
TopKRAS_s[,1:4]

# Other KRAS
i <- 0
i <- i+1; boxplotMutation(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, iCL = iCL, Gene_E = rownames(TopKRAS_s)[i], Mutation = "KRAS", tag = tag)

# Get Pairs
Pairs <- getPairs_mut(predictBiomarkers_mut = predictBiomarkers, co_pv = 0.05, co_lfdr = 0.2, co_DeltaEs = 1, Dir = FALSE, String = FALSE)
load("./data/output/geneInfo.RData")
Pairs <- merge(Pairs, Gene_Info, by.x = "Gene_E", by.y = "hgnc_symbol", all.x = T, all.y = F)
iM <- match(Pairs$Mutation, Gene_Info$hgnc_symbol)
Pairs$transcript_length <- Gene_Info$transcript_length[iM]
Pairs <- Pairs[order(Pairs$lfdr), ]
rownames(Pairs) <- NULL
i <- 0
i <- i+1; boxplotMutation(Essentiality = CCLE_demeter_match, CLxMut = CLxMut, iCL = iCL, Gene_E = Pairs$Gene_E[i], Mutation = Pairs$Mutation[i], tag = tag)


# View biomarkers for a gene
View(MagicCube_Mut["FOSL1", ,])
# Prepare data for Shiny --------------------------------------------------

# save(CCLE_demeter_match, CCLE_demeter_sample_info_match, CCLE_sample_info_match, CCLE_tpm_gn_match, CCLE_tpm_match, getBM, file = "./code/transcriptachilles/dataShiny/DataForShiny_small2.RData")

# CCLE_sample_info_match <- CCLE_sample_info_match[,c(1:5)]
# save(CCLE_demeter_match, CCLE_sample_info_match, CCLE_tpm_gn_match, CCLE_tpm_match, getBM, file = "./code/transcriptachilles/dataShiny/DataForShiny_small3.RData")

##### Clear all

load("./transcriptachilles/dataShiny/DataForShiny2.RData")
iM <- match(rownames(CCLE_demeter_match), rownames(CCLE_tpm_gn_match))
iM <- iM[!is.na(iM)]
CCLE_tpm_gn_match <- CCLE_tpm_gn_match[iM, ]


getBM_ntr <- as.data.frame(getBM %>% group_by(Gene_ID) %>% mutate(tr = n()))
getBM <- getBM_ntr

vars <- rowVars(CCLE_tpm_match)
thr_v <- 0.5
sum(vars < thr_v)

iLowV <- which(vars < thr_v)

CCLE_tpm_match <- CCLE_tpm_match[-iLowV, ]
getBM <- getBM[-iLowV, ]
identical(getBM$Transcript_ID, rownames(CCLE_tpm_match))

CCLE_sample_info_match <- CCLE_sample_info_match[,c(1:5)]

small <- FALSE
if(small){
  iCL <- which(CCLE_sample_info_match$Primary.Site == "lung" | CCLE_sample_info_match$Primary.Site == "stomach")
  CCLE_demeter_match <- CCLE_demeter_match[, iCL]
  CCLE_sample_info_match <- CCLE_sample_info_match[iCL, ]
  CCLE_tpm_gn_match <- CCLE_tpm_gn_match[, iCL]
  CCLE_tpm_match <- CCLE_tpm_match[,iCL]
}


# save(CCLE_demeter_match, CCLE_sample_info_match, CCLE_tpm_gn_match, CCLE_tpm_match, getBM, file = "./transcriptachilles/dataShiny/DataForShiny2_opt_2.RData")





